diff -Naur --exclude=CVS --exclude=configs linux/drivers/char/tty_io.c linux-openmosix/drivers/char/tty_io.c
--- linux/drivers/char/tty_io.c	2003-11-28 19:26:20.000000000 +0100
+++ linux-openmosix/drivers/char/tty_io.c	2004-02-05 10:51:14.000000000 +0100
@@ -511,7 +511,11 @@
 	}
 	
 	read_lock(&tasklist_lock);
+#ifdef CONFIG_MOSIX
+ 	for_each_local_task(p) {
+#else
  	for_each_task(p) {
+#endif /* CONFIG_MOSIX */
 		if ((tty->session > 0) && (p->session == tty->session) &&
 		    p->leader) {
 			send_sig(SIGHUP,p,1);
@@ -611,7 +615,11 @@
 	tty->pgrp = -1;
 
 	read_lock(&tasklist_lock);
+#ifdef CONFIG_MOSIX
+	for_each_local_task(p)
+#else
 	for_each_task(p)
+#endif /* CONFIG_MOSIX */
 	  	if (p->session == current->session)
 			p->tty = NULL;
 	read_unlock(&tasklist_lock);
@@ -1255,7 +1263,11 @@
 		struct task_struct *p;
 
 		read_lock(&tasklist_lock);
+#ifdef CONFIG_MOSIX
+		for_each_local_task(p) {
+#else
 		for_each_task(p) {
+#endif /* CONFIG_MOSIX */
 			if (p->tty == tty || (o_tty && p->tty == o_tty))
 				p->tty = NULL;
 		}
@@ -1602,7 +1614,11 @@
 			struct task_struct *p;
 
 			read_lock(&tasklist_lock);
+#ifdef CONFIG_MOSIX
+			for_each_local_task(p)
+#else
 			for_each_task(p)
+#endif /* CONFIG_MOSIX */
 				if (p->tty == tty)
 					p->tty = NULL;
 			read_unlock(&tasklist_lock);
@@ -1891,7 +1907,11 @@
 	if (tty->driver.flush_buffer)
 		tty->driver.flush_buffer(tty);
 	read_lock(&tasklist_lock);
+#ifdef CONFIG_MOSIX
+	for_each_local_task(p) {
+#else
 	for_each_task(p) {
+#endif /* CONFIG_MOSIX */
 		if ((p->tty == tty) ||
 		    ((session > 0) && (p->session == session))) {
 			send_sig(SIGKILL, p, 1);
diff -Naur --exclude=CVS --exclude=configs linux/drivers/message/fusion/mptctl.h linux-openmosix/drivers/message/fusion/mptctl.h
--- linux/drivers/message/fusion/mptctl.h	2003-08-25 13:44:42.000000000 +0200
+++ linux-openmosix/drivers/message/fusion/mptctl.h	2004-02-05 10:51:14.000000000 +0100
@@ -298,6 +298,12 @@
  * a bidirectional set up. Normal messages will have one or
  * both of these buffers NULL.
  */
+
+/* A hack due to the name clash with MF */
+#ifdef CONFIG_MOSIX
+#undef MF
+#endif
+
 struct mpt_ioctl_command {
 	mpt_ioctl_header hdr;
 	int		timeout;	/* optional (seconds) */
diff -Naur --exclude=CVS --exclude=configs linux/drivers/net/sk98lin/skdim.c linux-openmosix/drivers/net/sk98lin/skdim.c
--- linux/drivers/net/sk98lin/skdim.c	2003-11-28 19:26:20.000000000 +0100
+++ linux-openmosix/drivers/net/sk98lin/skdim.c	2004-02-05 10:51:17.000000000 +0100
@@ -2,8 +2,8 @@
  *
  * Name:	skdim.c
  * Project:	GEnesis, PCI Gigabit Ethernet Adapter
- * Version:	$Revision: 1.1 $
- * Date:	$Date: 2004/07/02 08:38:16 $
+ * Version:	$Revision: 1.1 $
+ * Date:	$Date: 2004/07/02 08:38:16 $
  * Purpose:	All functions to maintain interrupt moderation
  *
  ******************************************************************************/
@@ -26,6 +26,9 @@
  * History:
  *	
  *	$Log: openMosix-2.4.24-om1,v $
  *	Revision 1.1  2004/07/02 08:38:16  sithender
  *	Remove old kernel patch, and add current.
  *	
+ *	Revision 1.4  2004/02/05 09:51:17  sithender
+ *	adding openmosix patch for 2.4.24
+ *	
  *	Revision 1.2  2003/08/21 12:35:05  mlindner
  *	Fix: Corrected CPU detection and compile errors on single CPU machines
  *	
@@ -62,7 +65,7 @@
 
 #ifndef	lint
 static const char SysKonnectFileId[] =
-	"@(#) $Id: openMosix-2.4.24-om1,v 1.1 2004/07/02 08:38:16 sithender Exp $ (C) SysKonnect.";
+	"@(#) $Id: openMosix-2.4.24-om1,v 1.1 2004/07/02 08:38:16 sithender Exp $ (C) SysKonnect.";
 #endif
 
 #define __SKADDR_C
diff -Naur --exclude=CVS --exclude=configs linux/drivers/net/sk98lin/skgemib.c linux-openmosix/drivers/net/sk98lin/skgemib.c
--- linux/drivers/net/sk98lin/skgemib.c	2003-11-28 19:26:20.000000000 +0100
+++ linux-openmosix/drivers/net/sk98lin/skgemib.c	2004-02-05 10:51:17.000000000 +0100
@@ -2,8 +2,8 @@
  *
  * Name:	skgemib.c
  * Project:	GEnesis, PCI Gigabit Ethernet Adapter
- * Version:	$Revision: 1.1 $
- * Date:	$Date: 2004/07/02 08:38:16 $
+ * Version:	$Revision: 1.1 $
+ * Date:	$Date: 2004/07/02 08:38:16 $
  * Purpose:	Private Network Management Interface Management Database
  *
  ****************************************************************************/
@@ -27,6 +27,9 @@
  * History:
  *
  *	$Log: openMosix-2.4.24-om1,v $
  *	Revision 1.1  2004/07/02 08:38:16  sithender
  *	Remove old kernel patch, and add current.
  *	
+ *	Revision 1.6  2004/02/05 09:51:17  sithender
+ *	adding openmosix patch for 2.4.24
+ *	
  *	Revision 1.9  2003/05/23 12:55:20  tschilli
  *	OID_SKGE_BOARDLEVEL added.
  *	
diff -Naur --exclude=CVS --exclude=configs linux/drivers/scsi/cpqfcTSworker.c linux-openmosix/drivers/scsi/cpqfcTSworker.c
--- linux/drivers/scsi/cpqfcTSworker.c	2003-06-13 16:51:36.000000000 +0200
+++ linux-openmosix/drivers/scsi/cpqfcTSworker.c	2004-02-05 10:51:17.000000000 +0100
@@ -174,6 +174,10 @@
 	fs = init_task.fs;
 	current->fs = fs;
 	atomic_inc(&fs->count);
+#ifdef CONFIG_MOSIX
+	atomic_inc(&fs->users);
+#endif /* CONFIG_MOSIX */
+
 
 	siginitsetinv(&current->blocked, SHUTDOWN_SIGS);
 
diff -Naur --exclude=CVS --exclude=configs linux/drivers/usb/storage/usb.c linux-openmosix/drivers/usb/storage/usb.c
--- linux/drivers/usb/storage/usb.c	2003-08-25 13:44:42.000000000 +0200
+++ linux-openmosix/drivers/usb/storage/usb.c	2004-02-05 10:51:19.000000000 +0100
@@ -320,6 +320,9 @@
 	exit_files(current);
 	current->files = init_task.files;
 	atomic_inc(&current->files->count);
+#ifdef CONFIG_MOSIX_DFSA
+	atomic_inc(&current->files->users);
+#endif /* CONFIG_MOSIX_DFSA */
 	daemonize();
 	reparent_to_init();
 
diff -Naur --exclude=CVS --exclude=configs linux/fs/binfmt_aout.c linux-openmosix/fs/binfmt_aout.c
--- linux/fs/binfmt_aout.c	2001-11-03 02:39:20.000000000 +0100
+++ linux-openmosix/fs/binfmt_aout.c	2004-02-05 10:51:20.000000000 +0100
@@ -29,6 +29,10 @@
 #include <asm/uaccess.h>
 #include <asm/pgalloc.h>
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
+
 static int load_aout_binary(struct linux_binprm *, struct pt_regs * regs);
 static int load_aout_library(struct file*);
 static int aout_core_dump(long signr, struct pt_regs * regs, struct file *file);
@@ -108,6 +112,14 @@
 	dump.u_ar0 = (void *)(((unsigned long)(&dump.regs)) - ((unsigned long)(&dump)));
 #endif
 	dump.signal = signr;
+#ifdef CONFIG_MOSIX
+	if(current->mosix.dflags & DDEPUTY)
+	{
+		if(mosix_deputy_dump_thread(&dump))
+			goto end_coredump;
+	}
+	else
+#endif /* CONFIG_MOSIX */
 	dump_thread(regs, &dump);
 
 /* If the size of the dump file exceeds the rlimit, then see what would happen
@@ -189,7 +201,11 @@
  * memory and creates the pointer tables from them, and puts their
  * addresses on the "stack", returning the new stack pointer value.
  */
+#ifdef CONFIG_MOSIX
+unsigned long * create_aout_tables(char * p, struct linux_binprm * bprm)
+#else
 static unsigned long * create_aout_tables(char * p, struct linux_binprm * bprm)
+#endif /* CONFIG_MOSIX */
 {
 	char **argv, **envp;
 	unsigned long * sp;
@@ -258,6 +274,9 @@
 	unsigned long fd_offset;
 	unsigned long rlim;
 	int retval;
+#ifdef CONFIG_MOSIX
+	unsigned long start_stack;
+#endif /* CONFIG_MOSIX */
 
 	ex = *((struct exec *) bprm->buf);		/* exec-header */
 	if ((N_MAGIC(ex) != ZMAGIC && N_MAGIC(ex) != OMAGIC &&
@@ -296,6 +315,12 @@
 	set_personality(PER_LINUX);
 #endif
 
+#ifdef CONFIG_MOSIX
+	if(current->mosix.dflags & DDEPUTY)
+		mosix_deputy_init_aout_mm(&ex);
+	else
+	{
+#endif /* CONFIG_MOSIX */
 	current->mm->end_code = ex.a_text +
 		(current->mm->start_code = N_TXTADDR(ex));
 	current->mm->end_data = ex.a_data +
@@ -305,6 +330,9 @@
 
 	current->mm->rss = 0;
 	current->mm->mmap = NULL;
+#ifdef CONFIG_MOSIX
+	}
+#endif /* CONFIG_MOSIX */
 	compute_creds(bprm);
  	current->flags &= ~PF_FORKNOEXEC;
 #ifdef __sparc__
@@ -349,6 +377,9 @@
 			return error;
 		}
 			 
+#if defined(CONFIG_MOSIX) && !defined(__i386__)
+#error On platforms where "flush_icache_range" is non-empty, code must be adjusted
+#endif /* CONFIG_MOSIX */
 		flush_icache_range(text_addr, text_addr+ex.a_text+ex.a_data);
 	} else {
 		static unsigned long error_time, error_time2;
@@ -379,24 +410,38 @@
 			goto beyond_if;
 		}
 
+#ifdef CONFIG_MOSIX
+		error = do_mmap_down(bprm->file, N_TXTADDR(ex), ex.a_text,
+			PROT_READ | PROT_EXEC,
+			MAP_FIXED | MAP_PRIVATE | MAP_DENYWRITE | MAP_EXECUTABLE,
+			fd_offset);
+#else
 		down_write(&current->mm->mmap_sem);
 		error = do_mmap(bprm->file, N_TXTADDR(ex), ex.a_text,
 			PROT_READ | PROT_EXEC,
 			MAP_FIXED | MAP_PRIVATE | MAP_DENYWRITE | MAP_EXECUTABLE,
 			fd_offset);
 		up_write(&current->mm->mmap_sem);
+#endif /* CONFIG_MOSIX */
 
 		if (error != N_TXTADDR(ex)) {
 			send_sig(SIGKILL, current, 0);
 			return error;
 		}
 
+#ifdef CONFIG_MOSIX
+ 		error = do_mmap_down(bprm->file, N_DATADDR(ex), ex.a_data,
+				PROT_READ | PROT_WRITE | PROT_EXEC,
+				MAP_FIXED | MAP_PRIVATE | MAP_DENYWRITE | MAP_EXECUTABLE,
+				fd_offset + ex.a_text);
+#else
 		down_write(&current->mm->mmap_sem);
  		error = do_mmap(bprm->file, N_DATADDR(ex), ex.a_data,
 				PROT_READ | PROT_WRITE | PROT_EXEC,
 				MAP_FIXED | MAP_PRIVATE | MAP_DENYWRITE | MAP_EXECUTABLE,
 				fd_offset + ex.a_text);
 		up_write(&current->mm->mmap_sem);
+#endif /* CONFIG_MOSIX */
 		if (error != N_DATADDR(ex)) {
 			send_sig(SIGKILL, current, 0);
 			return error;
@@ -405,8 +450,27 @@
 beyond_if:
 	set_binfmt(&aout_format);
 
+#ifdef CONFIG_MOSIX
+	/* if DEPUTY, the REMOTE already did "set_brk" in aout_remote_init_mm */
+	if(!(current->mosix.dflags & DDEPUTY))
+#endif /* CONFIG_MOSIX */
 	set_brk(current->mm->start_brk, current->mm->brk);
 
+#ifdef CONFIG_MOSIX
+	if(current->mosix.dflags & DDEPUTY)
+	{
+		retval = mosix_deputy_setup_args(SETUP_ARGS_AS_AOUT,
+								&start_stack);
+		if(retval < 0)
+		{
+			send_sig(SIGKILL, current, 0);
+			return(retval);
+		}
+		mosix_obtain_registers(START_THREAD_REGS);
+	}
+	else
+	{
+#endif /* CONFIG_MOSIX */
 	retval = setup_arg_pages(bprm); 
 	if (retval < 0) { 
 		/* Someone check-me: is this error path enough? */ 
@@ -414,17 +478,46 @@
 		return retval;
 	}
 
+#ifdef CONFIG_MOSIX
+	start_stack =
+#endif /* CONFIG_MOSIX */
 	current->mm->start_stack =
 		(unsigned long) create_aout_tables((char *) bprm->p, bprm);
+#ifdef CONFIG_MOSIX
+	}
+#endif /* CONFIG_MOSIX */
 #ifdef __alpha__
 	regs->gp = ex.a_gpvalue;
 #endif
+#ifdef CONFIG_MOSIX
+	start_thread(regs, ex.a_entry, start_stack);
+#else
 	start_thread(regs, ex.a_entry, current->mm->start_stack);
+#endif /* CONFIG_MOSIX */
 	if (current->ptrace & PT_PTRACED)
 		send_sig(SIGTRAP, current, 0);
 	return 0;
 }
 
+#ifdef CONFIG_MOSIX
+void
+aout_remote_init_mm(struct exec *ex)
+{
+	register struct task_struct *p = current;
+
+	/* in principle we should first check for the "PER_LINUX" personality */
+	/* but then which LINUX does not have it??? */
+
+	p->mm->end_code = ex->a_text + (p->mm->start_code = N_TXTADDR(*ex));
+	p->mm->end_data = ex->a_data + (p->mm->start_data = N_DATADDR(*ex));
+	p->mm->brk = ex->a_bss + (p->mm->start_brk = N_BSSADDR(*ex));
+
+	p->mm->rss = 0;
+	p->mm->mmap = NULL;
+	set_brk(p->mm->start_brk, current->mm->brk);
+}
+#endif /* CONFIG_MOSIX */
+
 static int load_aout_library(struct file *file)
 {
 	struct inode * inode;
@@ -478,12 +571,19 @@
 		goto out;
 	}
 	/* Now use mmap to map the library into memory. */
+#ifdef CONFIG_MOSIX
+	error = do_mmap_down(file, start_addr, ex.a_text + ex.a_data,
+			PROT_READ | PROT_WRITE | PROT_EXEC,
+			MAP_FIXED | MAP_PRIVATE | MAP_DENYWRITE,
+			N_TXTOFF(ex));
+#else
 	down_write(&current->mm->mmap_sem);
 	error = do_mmap(file, start_addr, ex.a_text + ex.a_data,
 			PROT_READ | PROT_WRITE | PROT_EXEC,
 			MAP_FIXED | MAP_PRIVATE | MAP_DENYWRITE,
 			N_TXTOFF(ex));
 	up_write(&current->mm->mmap_sem);
+#endif /* CONFIG_MOSIX */
 	retval = error;
 	if (error != start_addr)
 		goto out;
diff -Naur --exclude=CVS --exclude=configs linux/fs/binfmt_elf.c linux-openmosix/fs/binfmt_elf.c
--- linux/fs/binfmt_elf.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/fs/binfmt_elf.c	2004-02-05 10:51:20.000000000 +0100
@@ -42,6 +42,10 @@
 
 #include <linux/elf.h>
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
+
 static int load_elf_binary(struct linux_binprm * bprm, struct pt_regs * regs);
 static int load_elf_library(struct file*);
 static unsigned long elf_map (struct file *, unsigned long, struct elf_phdr *, int, int);
@@ -106,12 +110,17 @@
 	}
 }
 
-static elf_addr_t * 
+static elf_addr_t *
 create_elf_tables(char *p, int argc, int envc,
 		  struct elfhdr * exec,
 		  unsigned long load_addr,
 		  unsigned long load_bias,
+#ifdef CONFIG_MOSIX
+		  unsigned long interp_load_addr, int ibcs,
+		  struct elf_tables_extras *extras)
+#else
 		  unsigned long interp_load_addr, int ibcs)
+#endif /* CONFIG_MOSIX */
 {
 	elf_caddr_t *argv;
 	elf_caddr_t *envp;
@@ -123,13 +132,18 @@
 
 	/*
 	 * Get hold of platform and hardware capabilities masks for
-	 * the machine we are running on.  In some cases (Sparc), 
+	 * the machine we are running on.  In some cases (Sparc),
 	 * this info is impossible to get, in others (i386) it is
 	 * merely difficult.
 	 */
 
+#ifdef CONFIG_MOSIX
+	hwcap = extras->hwcap;
+	k_platform = extras->platform;
+#else
 	hwcap = ELF_HWCAP;
 	k_platform = ELF_PLATFORM;
+#endif /* CONFIG_MOSIX */
 
 	if (k_platform) {
 		platform_len = strlen(k_platform) + 1;
@@ -192,12 +206,19 @@
 	NEW_AUX_ENT( 6, AT_BASE, interp_load_addr);
 	NEW_AUX_ENT( 7, AT_FLAGS, 0);
 	NEW_AUX_ENT( 8, AT_ENTRY, load_bias + exec->e_entry);
+#ifdef CONFIG_MOSIX
+	NEW_AUX_ENT(9, AT_UID, (elf_addr_t) extras->uid);
+	NEW_AUX_ENT(10, AT_EUID, (elf_addr_t) extras->euid);
+	NEW_AUX_ENT(11, AT_GID, (elf_addr_t) extras->gid);
+	NEW_AUX_ENT(12, AT_EGID, (elf_addr_t) extras->egid);
+#else
 	NEW_AUX_ENT( 9, AT_UID, (elf_addr_t) current->uid);
 	NEW_AUX_ENT(10, AT_EUID, (elf_addr_t) current->euid);
 	NEW_AUX_ENT(11, AT_GID, (elf_addr_t) current->gid);
 	NEW_AUX_ENT(12, AT_EGID, (elf_addr_t) current->egid);
+#endif /* CONFIG_MOSIX */
 #ifdef ARCH_DLINFO
-	/* 
+	/*
 	 * ARCH_DLINFO must come last so platform specific code can enforce
 	 * special alignment requirements on the AUXV if necessary (eg. PPC).
 	 */
@@ -244,11 +265,17 @@
 {
 	unsigned long map_addr;
 
+#ifdef CONFIG_MOSIX
+	map_addr = do_mmap_down(filep, ELF_PAGESTART(addr),
+			eppnt->p_filesz + ELF_PAGEOFFSET(eppnt->p_vaddr), prot,
+			type, eppnt->p_offset - ELF_PAGEOFFSET(eppnt->p_vaddr));
+#else
 	down_write(&current->mm->mmap_sem);
 	map_addr = do_mmap(filep, ELF_PAGESTART(addr),
 			   eppnt->p_filesz + ELF_PAGEOFFSET(eppnt->p_vaddr), prot, type,
 			   eppnt->p_offset - ELF_PAGEOFFSET(eppnt->p_vaddr));
 	up_write(&current->mm->mmap_sem);
+#endif /* CONFIG_MOSIX */
 	return(map_addr);
 }
 
@@ -350,7 +377,7 @@
 	/*
 	 * Now fill out the bss section.  First pad the last page up
 	 * to the page boundary, and then perform a mmap to make sure
-	 * that there are zero-mapped pages up to and including the 
+	 * that there are zero-mapped pages up to and including the
 	 * last bss page.
 	 */
 	padzero(elf_bss);
@@ -377,10 +404,23 @@
 	loff_t offset;
 	int retval;
 
+#ifdef CONFIG_MOSIX
+	if(current->mosix.dflags & DDEPUTY)
+		mosix_deputy_fix_elf_aout_interp(interp_ex->a_bss,
+					interp_ex->a_data, interp_ex->a_text);
+	else
+#endif /* CONFIG_MOSIX */
 	current->mm->end_code = interp_ex->a_text;
 	text_data = interp_ex->a_text + interp_ex->a_data;
+#ifdef CONFIG_MOSIX
+	if(!current->mosix.dflags & DDEPUTY)
+	{
+#endif /* CONFIG_MOSIX */
 	current->mm->end_data = text_data;
 	current->mm->brk = interp_ex->a_bss + text_data;
+#ifdef CONFIG_MOSIX
+	}
+#endif /* CONFIG_MOSIX */
 
 	switch (N_MAGIC(*interp_ex)) {
 	case OMAGIC:
@@ -403,6 +443,12 @@
 	retval = interpreter->f_op->read(interpreter, addr, text_data, &offset);
 	if (retval < 0)
 		goto out;
+#ifdef CONFIG_MOSIX
+#ifndef __i386__
+On platforms where "flush_icache_range" is non-empty,
+it has to distributed and run REMOTELY.
+#endif /* __i386__ */
+#endif /* CONFIG_MOSIX */
 	flush_icache_range((unsigned long)addr,
 	                   (unsigned long)addr + text_data);
 
@@ -446,7 +492,10 @@
   	struct exec interp_ex;
 	char passed_fileno[6];
 	struct files_struct *files;
-	
+#ifdef CONFIG_MOSIX
+	struct elf_tables_extras extras;
+#endif /* CONFIG_MOSIX */
+
 	/* Get the exec-header */
 	elf_ex = *((struct elfhdr *) bprm->buf);
 
@@ -595,7 +644,7 @@
 		  if (elf_interpreter) {
 		    retval = copy_strings_kernel(1,&passed_p,bprm);
 			if (retval)
-				goto out_free_dentry; 
+				goto out_free_dentry;
 		    bprm->argc++;
 		  }
 		}
@@ -614,6 +663,22 @@
 	}
 
 	/* OK, This is the point of no return */
+#ifdef CONFIG_MOSIX
+	if(current->mosix.dflags & DDEPUTY)
+	{
+		current->flags &= ~PF_FORKNOEXEC;
+		elf_entry = (unsigned long) elf_ex.e_entry;
+		SET_PERSONALITY(elf_ex, ibcs2_interpreter);
+		mosix_deputy_setup_args(SETUP_ARGS_AS_ELF, NULL);
+		if(IS_ERR((const unsigned *)bprm->p))
+		{
+			send_sig(SIGKILL, current, 0);
+			return(0);	/* too late for error */
+		}
+	}
+	else
+	{
+#endif /* CONFIG_MOSIX */
 	current->mm->start_data = 0;
 	current->mm->end_data = 0;
 	current->mm->end_code = 0;
@@ -631,6 +696,9 @@
 	}
 	
 	current->mm->start_stack = bprm->p;
+#ifdef CONFIG_MOSIX
+	}
+#endif /* CONFIG_MOSIX */
 
 	/* Now we do a little grungy work by mmaping the ELF image into
 	   the correct location in memory.  At this point, we assume that
@@ -646,7 +714,7 @@
 
 		if (unlikely (elf_brk > elf_bss)) {
 			unsigned long nbyte;
-	            
+
 			/* There was a PT_LOAD segment with p_memsz > p_filesz
 			   before this one. Map anonymous pages, if needed,
 			   and clear the area.  */
@@ -745,6 +813,26 @@
 
 	compute_creds(bprm);
 	current->flags &= ~PF_FORKNOEXEC;
+#ifdef CONFIG_MOSIX
+	extras.uid = current->uid;
+	extras.euid = current->euid;
+	extras.gid = current->gid;
+	extras.egid = current->egid;
+	extras.hwcap = ELF_HWCAP;
+	memcpy(extras.platform, ELF_PLATFORM, sizeof(extras.platform));
+	extras.platform[sizeof(extras.platform)-1] = '\0';
+	if(current->mosix.dflags & DDEPUTY)
+	    bprm->p = mosix_deputy_elf_setup((char *)bprm->p,
+		bprm->argc, bprm->envc, &elf_ex,
+		load_addr, load_bias, interp_load_addr,
+		(interpreter_type == INTERPRETER_AOUT ? 0 : 1),
+		interpreter_type == INTERPRETER_AOUT ?
+			strlen(passed_fileno) + 1 : 0,
+		elf_brk, end_code, start_code, start_data, end_data, elf_bss,
+		current->personality, &extras);
+	if(!(current->mosix.dflags & DDEPUTY))	/* must check again! */
+	{
+#endif /* CONFIG_MOSIX */
 	bprm->p = (unsigned long)
 	  create_elf_tables((char *)bprm->p,
 			bprm->argc,
@@ -752,7 +840,12 @@
 			&elf_ex,
 			load_addr, load_bias,
 			interp_load_addr,
+#ifdef CONFIG_MOSIX
+			(interpreter_type == INTERPRETER_AOUT ? 0 : 1),
+								&extras);
+#else
 			(interpreter_type == INTERPRETER_AOUT ? 0 : 1));
+#endif /* CONFIG_MOSIX */
 	/* N.B. passed_fileno might not be initialized? */
 	if (interpreter_type == INTERPRETER_AOUT)
 		current->mm->arg_start += strlen(passed_fileno) + 1;
@@ -786,11 +879,21 @@
 		   Since we do not have the power to recompile these, we
 		   emulate the SVr4 behavior.  Sigh.  */
 		/* N.B. Shouldn't the size here be PAGE_SIZE?? */
+#ifdef CONFIG_MOSIX
+		error = do_mmap_down(NULL, 0, 4096, PROT_READ | PROT_EXEC,
+				MAP_FIXED | MAP_PRIVATE, 0);
+#else
 		down_write(&current->mm->mmap_sem);
 		error = do_mmap(NULL, 0, 4096, PROT_READ | PROT_EXEC,
 				MAP_FIXED | MAP_PRIVATE, 0);
 		up_write(&current->mm->mmap_sem);
+#endif /* CONFIG_MOSIX */
+	}
+
+#ifdef CONFIG_MOSIX
 	}
+	mosix_obtain_registers(START_THREAD_REGS|ELF_PLAT_INIT_REGS);
+#endif /* CONFIG_MOSIX */
 
 #ifdef ELF_PLAT_INIT
 	/*
@@ -832,6 +935,69 @@
 	goto out;
 }
 
+#ifdef CONFIG_MOSIX
+/*
+ * the following routine is the remote portion of part of "do_load_elf_binary"
+ * and must be updated with changes to the former.
+ */
+unsigned long
+elf_remote_setup(char *p, int argc, int envc, struct elfhdr *exec,
+	unsigned long load_addr, unsigned long load_bias,
+	unsigned long interp_load_addr, int ibcs, int add_arg_start,
+	unsigned long elf_brk, unsigned long end_code, unsigned long start_code,
+	unsigned long start_data, unsigned long end_data, unsigned long elf_bss,
+	unsigned long personality, struct elf_tables_extras *extras)
+{
+	unsigned long ret;
+	struct exec_domain *new_domain = lookup_exec_domain(personality);
+
+	if(!new_domain)
+		mosix_go_home(2);	/* never returns */
+
+	if (current->exec_domain && current->exec_domain->module)
+		__MOD_DEC_USE_COUNT(current->exec_domain->module);
+	current->exec_domain = new_domain;
+	if (new_domain->module)
+		__MOD_INC_USE_COUNT(new_domain->module);
+	ret = (unsigned long)create_elf_tables(p, argc, envc, exec, load_addr,
+		load_bias, interp_load_addr, ibcs, extras);
+	current->mm->arg_start += add_arg_start;
+	current->mm->start_brk = current->mm->brk = elf_brk;
+	current->mm->end_code = end_code;
+	current->mm->start_code = start_code;
+	current->mm->start_data = start_data;
+	current->mm->end_data = end_data;
+	current->mm->start_stack = (unsigned long)p;
+
+	/* Calling set_brk effectively mmaps the pages that we need for the bss and break
+	   sections */
+	set_brk(elf_bss, elf_brk);
+
+	padzero(elf_bss);
+
+#if 0
+	printk("(start_brk) %x\n" , current->mm->start_brk);
+	printk("(end_code) %x\n" , current->mm->end_code);
+	printk("(start_code) %x\n" , current->mm->start_code);
+	printk("(end_data) %x\n" , current->mm->end_data);
+	printk("(start_stack) %x\n" , current->mm->start_stack);
+	printk("(brk) %x\n" , current->mm->brk);
+#endif
+
+	if ( personality == PER_SVR4 )
+	{
+		/* Why this, you ask???  Well SVr4 maps page 0 as read-only,
+		   and some applications "depend" upon this behavior.
+		   Since we do not have the power to recompile these, we
+		   emulate the SVr4 behavior.  Sigh.  */
+		/* N.B. Shouldn't the size here be PAGE_SIZE?? */
+		do_mmap(NULL, 0, 4096, PROT_READ | PROT_EXEC,
+				MAP_FIXED | MAP_PRIVATE, 0);
+	}
+	return(ret);
+}
+#endif /* CONFIG_MOSIX */
+
 /* This is really simpleminded and specialized - we are loading an
    a.out library that is given an ELF header. */
 
@@ -878,6 +1044,16 @@
 	while (elf_phdata->p_type != PT_LOAD) elf_phdata++;
 
 	/* Now use mmap to map the library into memory. */
+#ifdef CONFIG_MOSIX
+	error = do_mmap_down(file,
+			ELF_PAGESTART(elf_phdata->p_vaddr),
+			(elf_phdata->p_filesz +
+			 ELF_PAGEOFFSET(elf_phdata->p_vaddr)),
+			PROT_READ | PROT_WRITE | PROT_EXEC,
+			MAP_FIXED | MAP_PRIVATE | MAP_DENYWRITE,
+			(elf_phdata->p_offset -
+			 ELF_PAGEOFFSET(elf_phdata->p_vaddr)));
+#else
 	down_write(&current->mm->mmap_sem);
 	error = do_mmap(file,
 			ELF_PAGESTART(elf_phdata->p_vaddr),
@@ -888,6 +1064,7 @@
 			(elf_phdata->p_offset -
 			 ELF_PAGEOFFSET(elf_phdata->p_vaddr)));
 	up_write(&current->mm->mmap_sem);
+#endif /* CONFIG_MOSIX */
 	if (error != ELF_PAGESTART(elf_phdata->p_vaddr))
 		goto out_free_ph;
 
@@ -967,6 +1144,14 @@
 
 #define roundup(x, y)  ((((x)+((y)-1))/(y))*(y))
 
+#ifdef CONFIG_MOSIX
+int
+elf_maydump(struct vm_area_struct *vma)
+{
+	return(maydump(vma));
+}
+#endif /* CONFIG_MOSIX */
+
 /* An ELF note in memory */
 struct memelfnote
 {
@@ -1061,17 +1246,60 @@
 	struct elf_prstatus prstatus;	/* NT_PRSTATUS */
 	elf_fpregset_t fpu;		/* NT_PRFPREG */
 	struct elf_prpsinfo psinfo;	/* NT_PRPSINFO */
+#ifdef CONFIG_MOSIX
+	struct vmalist *vmas = NULL, *rvma;
+	unsigned long arg_start, arg_end;
+#endif /* CONFIG_MOSIX */
 
+#ifdef CONFIG_MOSIX
+	if(current->mosix.dflags & DDEPUTY)
+	{
+		segs = 0;
+		mosix_deputy_rusage(0);
+		if((i=mosix_deputy_list_vmas(&vmas, &arg_start, &arg_end)) < 0)
+		{
+			MOD_DEC_USE_COUNT;
+			return(0);
+		}
+		for(rvma = vmas ; i-- > 0 ; rvma++)
+		{
+			if(rvma->maydump)
+			{
+				int sz = rvma->vmend - rvma->vmstart;
+
+				if (size+sz >= limit)
+					break;
+				else
+					size += sz;
+			}
+			segs++;
+		}
+		vma = NULL;	/* to satisfy the silly compiler */
+	}
+	else
+#endif /* CONFIG_MOSIX */
 	/* first copy the parameters from user space */
 	memset(&psinfo, 0, sizeof(psinfo));
 	{
 		int i, len;
 
+#ifdef CONFIG_MOSIX
+		if(current->mosix.dflags & DDEPUTY)
+			len = arg_end - arg_start;
+		else
+#endif /* CONFIG_MOSIX */
 		len = current->mm->arg_end - current->mm->arg_start;
 		if (len >= ELF_PRARGSZ)
 			len = ELF_PRARGSZ-1;
+#ifdef CONFIG_MOSIX
+		copy_from_user(&psinfo.pr_psargs,
+			(current->mosix.dflags & DDEPUTY) ?
+			   (const char *)arg_start :
+  			      (const char *)current->mm->arg_start, len);
+#else
 		copy_from_user(&psinfo.pr_psargs,
 			      (const char *)current->mm->arg_start, len);
+#endif /* CONFIG_MOSIX */
 		for(i = 0; i < len; i++)
 			if (psinfo.pr_psargs[i] == 0)
 				psinfo.pr_psargs[i] = ' ';
@@ -1084,6 +1312,9 @@
 	 * This transfers the registers from regs into the standard
 	 * coredump arrangement, whatever that is.
 	 */
+#ifdef CONFIG_MOSIX
+	mosix_obtain_registers(ALL_REGISTERS);
+#endif /* CONFIG_MOSIX */
 #ifdef ELF_CORE_COPY_REGS
 	ELF_CORE_COPY_REGS(prstatus.pr_reg, regs)
 #else
@@ -1097,11 +1328,15 @@
 #endif
 
 	/* now stop all vm operations */
+#ifdef CONFIG_MOSIX
+	if(!(current->mosix.dflags & DDEPUTY))
+	{
+		down_write(&current->mm->mmap_sem);
+		segs = current->mm->map_count;
+	}
+#else	
 	down_write(&current->mm->mmap_sem);
 	segs = current->mm->map_count;
-
-#ifdef DEBUG
-	printk("elf_core_dump: %d segs %lu limit\n", segs, limit);
 #endif
 
 	/* Set up header */
@@ -1169,7 +1404,12 @@
 	notes[1].type = NT_PRPSINFO;
 	notes[1].datasz = sizeof(psinfo);
 	notes[1].data = &psinfo;
+#ifdef CONFIG_MOSIX
+	i = LOGICAL_STATE(current);
+	i = i ? ffz(~i) + 1 : 0;
+#else
 	i = current->state ? ffz(~current->state) + 1 : 0;
+#endif /* CONFIG_MOSIX */
 	psinfo.pr_state = i;
 	psinfo.pr_sname = (i < 0 || i > 5) ? '.' : "RSDZTD"[i];
 	psinfo.pr_zomb = psinfo.pr_sname == 'Z';
@@ -1185,6 +1425,11 @@
 	notes[2].data = current;
 
 	/* Try to dump the FPU. */
+#ifdef CONFIG_MOSIX
+	if(current->mosix.dflags & DDEPUTY)
+		prstatus.pr_fpvalid = mosix_deputy_dump_fpu(&fpu);
+	else
+#endif /* CONFIG_MOSIX */
 	prstatus.pr_fpvalid = dump_fpu (regs, &fpu);
 	if (!prstatus.pr_fpvalid)
 	{
@@ -1197,7 +1442,7 @@
 		notes[3].datasz = sizeof(fpu);
 		notes[3].data = &fpu;
 	}
-	
+
 	/* Write notes phdr entry */
 	{
 		struct elf_phdr phdr;
@@ -1223,6 +1468,30 @@
 	dataoff = offset = roundup(offset, ELF_EXEC_PAGESIZE);
 
 	/* Write program headers for segments dump */
+#ifdef CONFIG_MOSIX
+	if(current->mosix.dflags & DDEPUTY)
+	for(rvma = vmas , i = 0 ; i < segs ; rvma++ , i++) {
+		struct elf_phdr phdr;
+		size_t sz;
+
+		sz = rvma->vmend - rvma->vmstart;
+
+		phdr.p_type = PT_LOAD;
+		phdr.p_offset = offset;
+		phdr.p_vaddr = rvma->vmstart;
+		phdr.p_paddr = 0;
+		phdr.p_filesz = rvma->maydump ? sz : 0;
+		phdr.p_memsz = sz;
+		offset += phdr.p_filesz;
+		phdr.p_flags = (rvma->vmflags & VM_READ) ? PF_R : 0;
+		if (rvma->vmflags & VM_WRITE) phdr.p_flags |= PF_W;
+		if (rvma->vmflags & VM_EXEC) phdr.p_flags |= PF_X;
+		phdr.p_align = ELF_EXEC_PAGESIZE;
+
+		DUMP_WRITE(&phdr, sizeof(phdr));
+	}
+	else
+#endif /* CONFIG_MOSIX */
 	for(vma = current->mm->mmap; vma != NULL; vma = vma->vm_next) {
 		struct elf_phdr phdr;
 		size_t sz;
@@ -1250,6 +1519,23 @@
 
 	DUMP_SEEK(dataoff);
 
+#ifdef CONFIG_MOSIX
+	if(current->mosix.dflags & DDEPUTY)
+	{
+		for(i = 0 , rvma = vmas ; i < segs ; rvma++ , i++)
+		if(rvma->maydump)
+		{
+			unsigned long addr = rvma->vmstart;
+			unsigned long len = rvma->vmend - rvma->vmstart;
+
+#ifdef DEBUG
+			printk("elf_core_dump: writing %08lx %lx\n", addr, len);
+#endif
+			DUMP_WRITE((void *)addr, len);
+		}
+	}
+	else
+#endif /* CONFIG_MOSIX */
 	for(vma = current->mm->mmap; vma != NULL; vma = vma->vm_next) {
 		unsigned long addr;
 
@@ -1292,7 +1578,14 @@
 	}
 
  end_coredump:
+#ifdef CONFIG_MOSIX
+	if(vmas)
+		kfree(vmas);
+#endif /* CONFIG_MOSIX */
 	set_fs(fs);
+#ifdef CONFIG_MOSIX
+	if (!(current->mosix.dflags & DDEPUTY))
+#endif		
 	up_write(&current->mm->mmap_sem);
 	return has_dumped;
 }
diff -Naur --exclude=CVS --exclude=configs linux/fs/buffer.c linux-openmosix/fs/buffer.c
--- linux/fs/buffer.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/fs/buffer.c	2004-02-05 10:51:20.000000000 +0100
@@ -53,6 +53,10 @@
 #include <asm/bitops.h>
 #include <asm/mmu_context.h>
 
+#ifdef CONFIG_MOSIX_DFSA
+#include <linux/dfsa_interface.h>
+#endif /* CONFIG_MOSIX_DFSA */
+
 #define NR_RESERVED (10*MAX_BUF_PER_PAGE)
 #define MAX_UNUSED_BUFFERS NR_RESERVED+20 /* don't ever have more than this 
 					     number of unused buffer heads */
@@ -425,6 +429,10 @@
 	struct inode * inode;
 	int ret, err;
 
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_syscall_on_file(fd, 0);
+#endif /* CONFIG_MOSIX_DFSA */
+
 	ret = -EBADF;
 	file = fget(fd);
 	if (!file)
@@ -464,7 +472,7 @@
 
 	if (unlikely(!file->f_op || !file->f_op->fsync))
 		return -EINVAL;
-	
+
 	dentry = file->f_dentry;
 	inode = dentry->d_inode;
 
@@ -484,6 +492,10 @@
 	struct inode *inode;
 	int ret;
 
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_syscall_on_file(fd, 0);
+#endif /* CONFIG_MOSIX_DFSA */
+
 	ret = -EBADF;
 	file = fget(fd);
 	if (!file)
diff -Naur --exclude=CVS --exclude=configs linux/fs/dcache.c linux-openmosix/fs/dcache.c
--- linux/fs/dcache.c	2003-06-13 16:51:37.000000000 +0200
+++ linux-openmosix/fs/dcache.c	2004-02-05 10:51:20.000000000 +0100
@@ -26,6 +26,10 @@
 
 #include <asm/uaccess.h>
 
+#ifdef CONFIG_MOSIX
+#include <linux/smp_lock.h>
+#endif /* CONFIG_MOSIX */
+
 #define DCACHE_PARANOIA 1
 /* #define DCACHE_DEBUG 1 */
 
@@ -833,6 +837,11 @@
 void d_rehash(struct dentry * entry)
 {
 	struct list_head *list = d_hash(entry->d_parent, entry->d_name.hash);
+
+#ifdef CONFIG_MOSIX_FS
+	if(entry->d_flags & DCACHE_NO_CACHE)
+		return;
+#endif /* CONFIG_MOSIX_FS */
 	if (!list_empty(&entry->d_hash)) BUG();
 	spin_lock(&dcache_lock);
 	list_add(&entry->d_hash, list);
@@ -905,6 +914,9 @@
 	spin_lock(&dcache_lock);
 	/* Move the dentry to the target hash queue */
 	list_del(&dentry->d_hash);
+#ifdef CONFIG_MOSIX_FS
+	if(!(dentry->d_flags & DCACHE_NO_CACHE))
+#endif /* CONFIG_MOSIX_FS */
 	list_add(&dentry->d_hash, &target->d_hash);
 
 	/* Unhash the target: dput() will then get rid of it */
@@ -950,6 +962,9 @@
 
 	*--end = '\0';
 	buflen--;
+#ifdef CONFIG_MOSIX_FS
+	if (!(dentry->d_flags & DCACHE_NO_CACHE))
+#endif /* CONFIG_MOSIX_FS */
 	if (!IS_ROOT(dentry) && list_empty(&dentry->d_hash)) {
 		buflen -= 10;
 		end -= 10;
@@ -1024,19 +1039,40 @@
 	char *page = (char *) __get_free_page(GFP_USER);
 
 	if (!page)
+#ifdef CONFIG_MOSIX_DFSA
+		return ((current->mosix.dflags & DREMOTE) ?
+							-EDOITATHOME : -ENOMEM);
+#else
 		return -ENOMEM;
+#endif /* CONFIG_MOSIX_DFSA */
 
 	read_lock(&current->fs->lock);
+#ifdef CONFIG_MOSIX_DFSA
+	if(!current->fs->pwd)	/* we are REMOTE and not on a DFSA FS! */
+	{
+		read_unlock(&current->fs->lock);
+		return(-EDOITATHOME);
+	}
+#endif /* CONFIG_MOSIX_DFSA */
 	pwdmnt = mntget(current->fs->pwdmnt);
 	pwd = dget(current->fs->pwd);
 	rootmnt = mntget(current->fs->rootmnt);
 	root = dget(current->fs->root);
 	read_unlock(&current->fs->lock);
+#if defined(CONFIG_MOSIX_DFSA) || defined(CONFIG_MOSIX_FS)
+	if(pwd->d_inode->i_op && pwd->d_inode->i_op->check_path)
+		pwd->d_inode->i_op->check_path(pwd);
+#endif /* CONFIG_MOSIX_DFSA || CONFIG_MOSIX_FS */
 
 	error = -ENOENT;
 	/* Has the current directory has been unlinked? */
 	spin_lock(&dcache_lock);
+#ifdef CONFIG_MOSIX_FS
+	if (pwd->d_parent == pwd || !list_empty(&pwd->d_hash) ||
+					(pwd->d_flags & DCACHE_NO_CACHE)) {
+#else
 	if (pwd->d_parent == pwd || !list_empty(&pwd->d_hash)) {
+#endif /* CONFIG_MOSIX_FS */
 		unsigned long len;
 		char * cwd;
 
